package org.vraptor;

import org.vraptor.view.ViewException;

/**
 * Interface for logic flow. Either the method execute or forward should be
 * called.
 * 
 * @author Guilherme Silveira
 */
public interface LogicFlow {

	/**
	 * Executes the next interceptor or logic
	 * 
	 * @throws LogicException
	 *             some logic or interceptor problem
	 * @throws ViewException
	 *             some view problem
	 * 
	 */
	void execute() throws ViewException, LogicException;

	/**
	 * Returns the respective LogicRequest for this flow
	 * 
	 * @return 
	 */
	LogicRequest getLogicRequest();

}
