package org.vraptor;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.vraptor.http.Dispatcher;
import org.vraptor.http.DispatcherFactory;

/**
 * VRaptor servlet contains a vraptor dispatcher capable of answering web
 * requests.
 * 
 * @author Guilherme Silveira
 * @author Nico Steppat
 */
public class VRaptorServlet extends HttpServlet {
	static final Logger LOG = Logger.getLogger(VRaptorServlet.class);

	/** serialversion uid */
	private static final long serialVersionUID = 1084551538406918487L;

	private Dispatcher dispatcher;

	public VRaptorServlet() {
	}
	
	public VRaptorServlet(Dispatcher dispatcher) {
		this.dispatcher = dispatcher;
	}
	
	@Override
	public synchronized void init() throws ServletException {
		this.dispatcher = new DispatcherFactory().configure(getServletContext());
	}

	@Override
	protected void service(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse)
			throws ServletException, IOException {
		if (LOG.isDebugEnabled()) {
			LOG.debug("new request to " + httpServletRequest.getRequestURI());
		}

		dispatcher.dispatch(httpServletRequest, httpServletResponse, getServletContext());
	}

	@Override
	public void destroy() {
		super.destroy();
		dispatcher.destroy();
	}
}
