package org.vraptor.core;

import org.vraptor.http.VRaptorServletRequest;
import org.vraptor.http.VRaptorServletResponse;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Simple wrapper for request, response and context
 * 
 * @author Paulo Silveira
 * @since 2.2.3
 */
public class WebRequest {

	private VRaptorServletRequest request;

	private VRaptorServletResponse response;

	private ServletContext context;

	public WebRequest(VRaptorServletRequest request, VRaptorServletResponse response, ServletContext context) {
		super();
		this.request = request;
		this.response = response;
		this.context = context;
	}

	public ServletContext getContext() {
		return context;
	}

	public VRaptorServletRequest getRequest() {
		return request;
	}

	public VRaptorServletResponse getResponse() {
		return response;
	}

}
