package org.vraptor.plugin.niceurls;

import java.util.Map;

import org.vraptor.Interceptor;
import org.vraptor.LogicException;
import org.vraptor.LogicFlow;
import org.vraptor.plugin.niceurls.resolver.URLData;
import org.vraptor.view.ViewException;

public class InjectingURLParametersInterceptor implements Interceptor {
	public void intercept(LogicFlow flow) throws ViewException, LogicException {
		URLData urlData = getUrlDataFromRequest(flow);

		Map<String, String> paramsFromUrl = urlData.getParameters();
		for (Map.Entry<String, String> param : paramsFromUrl.entrySet()) {
			setRequestParam(param.getKey(), param.getValue(), flow);
		}
		
		flow.execute();
	}

	private URLData getUrlDataFromRequest(LogicFlow logicFlow) {
		return (URLData) logicFlow.getLogicRequest().getRequestContext().getAttribute(NiceURLFilter.URLDATA_ATTRIBUTE);
	}

	private void setRequestParam(String key, String value, LogicFlow flow) {
		flow.getLogicRequest().getRequestContext().getRequest().addParameterValue(key, value);
	}
}
