package org.vraptor.plugin.niceurls;

import org.vraptor.ValidationErrorsFactory;
import org.vraptor.component.ComponentContainer;
import org.vraptor.component.ComponentManager;
import org.vraptor.scope.ApplicationContext;
import org.vraptor.url.LogicLocator;
import org.vraptor.url.ViewLocator;
import org.vraptor.view.ViewManager;

public class NiceURLComponentContainer implements ComponentContainer {
	private final ComponentContainer delegate;
	private LogicLocator niceUrlLogicLocator;
	private ViewLocator niceUrlViewLocator;

	public NiceURLComponentContainer(ComponentContainer delegateComponentContainer) {
		this.delegate = delegateComponentContainer;
	}

	public LogicLocator getLogicLocator() {
		if (niceUrlLogicLocator == null)
			this.niceUrlLogicLocator = new NiceURLLogicLocator(getComponentManager());
		
		return niceUrlLogicLocator;
	}
	
	public ApplicationContext getApplicationContext() {
		return delegate.getApplicationContext();
	}

	public ComponentManager getComponentManager() {
		return delegate.getComponentManager();
	}

	public ValidationErrorsFactory getValidationErrorsFactory() {
		return delegate.getValidationErrorsFactory();
	}

	public ViewLocator getViewLocator() {
		if (niceUrlViewLocator == null)
			this.niceUrlViewLocator = new NiceURLViewLocator();
		
		return niceUrlViewLocator;
	}

	public ViewManager getViewManager() {
		return delegate.getViewManager();
	}
}
