package org.vraptor.plugin.niceurls;

import org.apache.log4j.Logger;
import org.vraptor.component.ComponentManager;
import org.vraptor.component.ComponentNotFoundException;
import org.vraptor.component.ComponentType;
import org.vraptor.component.LogicMethod;
import org.vraptor.component.LogicNotFoundException;
import org.vraptor.http.VRaptorServletRequest;
import org.vraptor.plugin.niceurls.resolver.URLData;
import org.vraptor.url.InvalidURLException;
import org.vraptor.url.LogicLocator;

public class NiceURLLogicLocator implements LogicLocator {
	private static final Logger LOG = Logger.getLogger(NiceURLLogicLocator.class);

	private final ComponentManager manager;

	public NiceURLLogicLocator(ComponentManager manager) {
		this.manager = manager;
	}

	public LogicMethod locate(VRaptorServletRequest req) throws InvalidURLException, LogicNotFoundException,
			ComponentNotFoundException {
		URLData result = (URLData) req.getAttribute(NiceURLFilter.URLDATA_ATTRIBUTE);

		ComponentType component = manager.getComponent(result.getComponentName(), result.getLogicName());
		LogicMethod method = component.getLogic(result.getLogicName());

		if (LOG.isDebugEnabled()) {
			LOG.debug("logic method extracted: " + method);
		}

		return method;
	}
}
