package org.vraptor.plugin.niceurls;

import org.apache.log4j.Logger;
import org.vraptor.VRaptorException;
import org.vraptor.component.ComponentManager;
import org.vraptor.component.ComponentType;
import org.vraptor.interceptor.InterceptorType;
import org.vraptor.plugin.VRaptorPlugin;
import org.vraptor.plugin.niceurls.component.RedirectComponent;
import org.vraptor.webapp.WebApplication;

public class NiceURLPlugin implements VRaptorPlugin {
	private static final Logger LOG = Logger.getLogger(NiceURLPlugin.class); 

	public void init(WebApplication application) throws VRaptorException {
		LOG.info("Initializing NiceURLs Plugin");
		ComponentManager componentManager = application.getComponentManager();
		registerComponent(componentManager);
		registerInterceptor(componentManager);
	}

	void registerComponent(ComponentManager componentManager) throws VRaptorException {
		ComponentType redirectComponentType = componentManager.getComponentType(RedirectComponent.class);
		componentManager.register(redirectComponentType);
	}

	void registerInterceptor(ComponentManager componentManager) {
		InterceptorType interceptorType = InterceptorType.getType(InjectingURLParametersInterceptor.class);
		for (ComponentType component : componentManager.getComponents()) {
			if (LOG.isDebugEnabled()) {
				LOG.debug("Wrapping " + component.getComponentClass().getName() + " for nice urls parameter injection support.");
			}
			component.getInterceptors().add(interceptorType);
		}
	}

}
