package org.vraptor.plugin.niceurls.consequences;

import org.vraptor.plugin.niceurls.resolver.ParamsContext;
import org.vraptor.plugin.niceurls.resolver.URLData;
import org.vraptor.plugin.niceurls.resolver.Route;

/**
 * Allow user to use parameter variables in consequence definitions.
 * Ex.
 * 		#{component}.#{logic} 
 */
public class DynamicRouteConsequence implements RouteConsequence {

	public URLData generateResult(Route route, ParamsContext context) {
		URLData result = new URLData();
		result.setParamsContext(context);
				
		String finalConsequence = route.evaluateTo(context);
		String[] split = finalConsequence.split("\\.");
		result.setComponentName(split[0]);
		result.setLogicName(split[1]);
		
		boolean hasViewType = split.length >=3;
		if(hasViewType) {
			result.setViewType(split[2]);
		}
		
		return result;
	}
}
