package org.vraptor.plugin.niceurls.consequences;

import org.vraptor.plugin.niceurls.resolver.ParamsContext;
import org.vraptor.plugin.niceurls.resolver.URLData;
import org.vraptor.plugin.niceurls.resolver.Route;

/**
 * A redirection consequence points to a uri and should use our VRaptorRedirector
 */
public class RedirectRouteConsequence implements RouteConsequence {

	private static final String REDIRECTOR_COMPONENT = "VRaptorRedirector";
	private static final String REDIRECTOR_LOGIC = "movedTemporarily";

	public URLData generateResult(Route route, ParamsContext context) {
		URLData result = new URLData();
		result.setParamsContext(context);
		
		result.setComponentName(REDIRECTOR_COMPONENT);
		result.setLogicName(REDIRECTOR_LOGIC);
		context.addParameter("uri", route.evaluateTo(context));

		return result;
	}

}
