package org.vraptor.plugin.niceurls.resolver;

import java.util.Map;

/**
 * Represents data from an URL, obtained from a URLResolver
 */
public class URLData {

	private String logicName;
	private String componentName;
	private ParamsContext paramsContext;
	private String viewType;

	public URLData() {
	}

	public URLData(String logicName, String componentName, ParamsContext paramsContext) {
		this.logicName = logicName;
		this.componentName = componentName;
		this.paramsContext = paramsContext;
	}

	public URLData(String logicName, String componentName, String viewType, ParamsContext paramsContext) {
		this.logicName = logicName;
		this.componentName = componentName;
		this.paramsContext = paramsContext;
		this.viewType = viewType;
	}

	public String getComponentName() {
		return componentName;
	}

	public String getLogicName() {
		return logicName;
	}

	public void setParamsContext(ParamsContext paramsContext) {
		this.paramsContext = paramsContext;
	}

	public String getParameter(String key) {
		return paramsContext.getParameter(key);
	}

	public Map<String, String> getParameters() {
		return paramsContext.getParameters();
	}

	@Override
	public String toString() {
		return String.format("[component: %s, logic: %s]", componentName, logicName);
	}

	public void setComponentName(String componentName) {
		this.componentName = componentName;
	}

	public void setLogicName(String logicName) {
		this.logicName = logicName;
	}

	public String getViewType() {
		return viewType;
	}

	public void setViewType(String viewType) {
		this.viewType = viewType;
	}

}
