package org.vraptor.url;

import javax.servlet.http.HttpServletRequest;

import org.vraptor.component.ComponentNotFoundException;
import org.vraptor.component.LogicMethod;
import org.vraptor.component.LogicNotFoundException;
import org.vraptor.http.VRaptorServletRequest;

/**
 * Locates the logic method for this request.
 * 
 * @author Guilherme Silveira
 */
public interface LogicLocator {

	/**
	 * Returns the selected logic method for this request.
	 * @throws LogicNotFoundException 
	 * @throws ComponentNotFoundException 
	 */
	LogicMethod locate(VRaptorServletRequest req) throws InvalidURLException, LogicNotFoundException,
            ComponentNotFoundException;

}
